#include "tdco.ch"
#include "aplic.ch"
#include "InKey.ch"
#include "butano.ch"

APLICATION "Butano. (Reducida)"

   VERSION ID cVERSION
   PROGRAMING BY "Alfonso Fraguas Bravo"
   HELP SYSTEM NIL
   USAGE LINKER "BLinker"

   RtnSetPos( 0, MaxCol() )

   SCREEN
   INIT MESSAGE


   /*
    * Definicin de las esctructuras de los ficheros
    */
   DEFINE FILE cPATH+"Clientes.DBF"
      FIELD Nombre		  LEN 20 // 01
      FIELD Apellido_1		  LEN 38 // 02
      FIELD Apellido_2		  LEN 38 // 03
      FIELD NIF_2_Dig		  LEN 02 // 04
      FIELD NIF_12_Dig		  LEN 12 // 05
      FIELD Tipo_Via		  LEN 02 // 06
      FIELD Cod_Calle		  LEN 04 // 07
      FIELD Numero		  LEN 04 // 08
      FIELD Bloque		  LEN 03 // 09
      FIELD Portal		  LEN 03 // 11
      FIELD Escalera		  LEN 02 // 12
      FIELD Piso		  LEN 02 // 13
      FIELD Puerta		  LEN 03 // 14
      FIELD Edf_Urb		  LEN 19 // 15
      FIELD Cod_Munici		  LEN 03 // 16
      FIELD Cod_Provin		  LEN 02 // 17
      FIELD Prefijo		  LEN 03 // 18
      FIELD Telefono		  LEN 07 // 19
      FIELD Cont_Poliz		  LEN 09 // 20
      FIELD Reg_Num		  LEN 05 // 21
      FIELD F_Alta     TYPE Date	 // 22
      FIELD F_Baja     TYPE Date	 // 23
      FIELD F_U_Visita TYPE Date	 // 24
      FIELD Activo     TYPE Char  LEN 01 // 25
      FIELD Cod_Instal TYPE Char  LEN 02 // 26
      FIELD Notas      TYPE Memo	 // 27
      FIELD Localidad  TYPE Char  LEN 22 // 28
      FIELD Cod_Nomenc TYPE Char  LEN 03 // 29
   END FILE

   DEFINE FILE cPATH+"Envase.DBF"
      FIELD Cont_Poliz		  LEN 09  // 01
      FIELD UD_125     TYPE Num   LEN 02  // 02
      FIELD UD_110     TYPE Num   LEN 02  // 03
      FIELD UI_350     TYPE Num   LEN 02  // 04
      FIELD K_120      TYPE Num   LEN 02  // 05
      FIELD AM_120     TYPE Num   LEN 02  // 06
      FIELD Cocina_N_R TYPE Logic	  // 06
      FIELD Cocina_S_R TYPE Logic	  // 06
      FIELD Calentador TYPE Logic	  // 06
      FIELD Caldera    TYPE Logic	  // 06
      FIELD Estufa     TYPE Logic	  // 06
      FIELD Otros_N_R  TYPE Logic	  // 06
      FIELD Otros_S_R  TYPE Logic	  // 06
      FIELD N_Envases1 TYPE Num   LEN 02  // 06
      FIELD P_Envases1 TYPE Num   LEN 05  // 06
      FIELD N_Envases2 TYPE Num   LEN 02  // 06
      FIELD P_Envases2 TYPE Num   LEN 05  // 06
      FIELD Supemento		  LEN 05  // 06
      FIELD S_Envases  TYPE Num   LEN 02  // 06
      FIELD S_Pesetas  TYPE Num   LEN 05  // 06
   END FILE

   // TABLAS
   DEFINE LOOKUP cPATH+"Vias.DBF"     CODE 02 DESC 30
   DEFINE LOOKUP cPATH+"Provinci.DBF" CODE 02 DESC 20
   DEFINE LOOKUP cPATH+"Municipi.DBF" CODE 03 DESC 30
   DEFINE LOOKUP cPATH+"Calles.DBF"   CODE 04 DESC 30
   DEFINE LOOKUP cPATH+"Instalad.DBF" CODE 02 DESC 30
   DEFINE LOOKUP cPATH+"Nomencla.DBF" CODE 03 DESC 20

   INIT FILES
      // MAESTROS
      USAR Clientes.DBF NEW SHARED WAIT 5;
	   LABEL "Datos generales de Clientes";
       INDEX CliName.ntx KEY Field->Apellido_1+Field->Apellido_2+Field->Nombre LABEL "Alfabetico por Apellidos y Nombre",;
         CliDomi.ntx KEY Field->Cod_Calle+Field->Numero+Field->Piso+Field->Puerta LABEL "Datos del Domicilio",;
         CliNIF.ntx KEY Field->NIF_12_Dig LABEL "N de Identidicacin Fiscal (NIF)",;
         CliPoli.ntx KEY Field->Cont_poliz LABEL "N de Contrato / Poliza",;
         Clia1.ntx KEY Field->Apellido_1 LABEL "Apellido 1",;
         Clia2.ntx KEY Field->Apellido_2 LABEL "Apellido 2",;
         CliN2.ntx KEY Field->Nombre     LABEL "Nombre"

      USAR Envase.DBF NEW SHARED WAIT 5;
	   LABEL "Datos auxiliares de Clientes. Evases y Aparatos";
       INDEX EnvPoli.ntx KEY Field->Cont_Poliz LABEL "N de Contrato / Poliza"

      // TABLAS
      USAR Vias.DBF NEW SHARED WAIT 5;
	   LABEL "Tabla de Tipos de Vias";
       INDEX ViaCod.ntx KEY Field->Codigo LABEL "Cdigo de la Via",;
         ViaDes.ntx KEY Field->Descripcio LABEL "Descripcin de la Via"

      USAR Provinci.DBF NEW SHARED WAIT 5;
	   LABEL "Tabla de Provincias";
       INDEX ProvCod.ntx KEY Field->Codigo LABEL "Cdigo de Provincia",;
         ProvDes.ntx KEY Field->Descripcio LABEL "Descripcin de la Provincia"


      USAR Municipi.DBF NEW SHARED WAIT 5;
	   LABEL "Tabla de Municipios";
       INDEX MuniCod.ntx KEY Field->Codigo LABEL "Cdigo del Municipio",;
         MuniDes.ntx KEY Field->Descripcio LABEL "Descripcin del Municipio"

      USAR Calles.DBF NEW SHARED WAIT 5;
	   LABEL "Tabla de Calles";
       INDEX CalleCod.ntx KEY Field->Codigo LABEL "Cdigo de la Calle",;
         CalleDes.ntx KEY Field->Descripcio LABEL "Descripcin de la Calle"

      USAR Instalad.DBF NEW SHARED WAIT 5;
	   LABEL "Tabla de Instaladores";
       INDEX InstaCod.ntx KEY Field->Codigo LABEL "Cdigo del Instalador",;
         InstaDes.ntx KEY Field->Descripcio LABEL "Descripcin del Instalador"

      USAR Nomencla.DBF NEW SHARED WAIT 5;
	   LABEL "Tabla de Nomenclatores";
       INDEX NomenCod.ntx KEY Field->Codigo LABEL "Cdigo del Nomenclator",;
         NomenDes.ntx KEY Field->Descripcio LABEL "Descripcin del Nomenclatror"

  SELECT CLIENTES   // Para que sea el fichero por defecto de la aplicacin

  // Inicializamos las tablas
  LeeTblVias()
  LeeTblProv()
  LeeTblMunici()
  LeeTblCalles()
  LeeTblInstalad()
  LeeTblNomencla()


   DEFINE MENU
     INHERIT FROM IHInformation() INTO M_INFORMATION


     // MENU MAESTROS
     ADD ITEM "  &Clientes  " ACTIVE;
			    EXEC CliMgr();
     INTO M_SYSTEM

     ADD ITEM "  &Envases y Aparatos " ACTIVE;
			    EXEC EnvMgr();
     INTO M_SYSTEM

     // MENU TABLAS
     ADD ITEM "  &Vias  "   ACTIVE;
			      EXEC ViasMgr();
     INTO M_ARRAYS

     SEPARATOR INTO M_ARRAYS

     ADD ITEM "  &Provincias  " ACTIVE;
			      EXEC ProvMgr();
     INTO M_ARRAYS

     ADD ITEM "  &Municipios  "   ACTIVE;
				  EXEC MuniMgr();
     INTO M_ARRAYS

     ADD ITEM "  &Nomenclatores  "   ACTIVE;
				  EXEC NomeMgr();
     INTO M_ARRAYS

     SEPARATOR INTO M_ARRAYS

     ADD ITEM "  &Calles  "   ACTIVE;
			      EXEC CalleMgr();
     INTO M_ARRAYS

     SEPARATOR INTO M_ARRAYS

     ADD ITEM "  &Instaladores  "   ACTIVE;
			      EXEC InstMgr();
     INTO M_ARRAYS

     INHERIT FROM IHTasks() INTO M_TASKS

     DEL ITEM 5 INTO M_TASKS

     ADD ITEM "  Poliza de &Renovacin  ";
     INTO M_TASKS

     ADD ITEM "  &Contratos  ";
     INTO M_TASKS

     ADD ITEM "  &Punteo     " ;
     INTO M_TASKS

     SEPARATOR INTO M_TASKS

     ADD ITEM "  E&xportar  " ;
     INTO M_TASKS


     INHERIT FROM IHUtility() INTO M_UTILITY

     INHERIT FROM IHHelp() INTO M_HELP


   SCREEN

   QUICK EXIT
   SET KEY K_CTRL_K TO MemStatus()

   EXEC MENU

END APLICATION

//---------------------------------------------------------------------------//

function LeeTblProv( Read )
static aProvincia := {}

  local nSelect := Select()

  if PCount() == 1
     aProvincia := {}
  end if

  SELECT PROVINCI
  GO TOP

  if Len( aProvincia ) == 0
    while !eof()
      aadd( aProvincia, { PROVINCI->CODIGO, PROVINCI->DESCRIPCIO } )
      SKIP
    end do
    if Len( aProvincia ) == 0
       aadd( aProvincia, { "", "" } )
    end if
  end if

  SELECT (nSelect)

return( aProvincia )

//---------------------------------------------------------------------------//

function LeeTblVias( Read )
static aVias := {}

  local nSelect := Select()

  if PCount() == 1
     aVias := {}
  end if

  SELECT VIAS
  GO TOP

  if Len( aVias ) == 0
    while !eof()
      aadd( aVias, { VIAS->CODIGO, VIAS->DESCRIPCIO } )
      SKIP
    end do
    if Len( aVias ) == 0
       aadd( aVias, { "", "" } )
    end if
  end if

  SELECT (nSelect)

return( aVias )

//---------------------------------------------------------------------------//

function LeeTblMunici( Read )
static aMunicipio := {}

  local nSelect := Select()

  if PCount() == 1
     aMunicipio := {}
  end if

  SELECT MUNICIPI
  GO TOP

  if Len( aMunicipio ) == 0
    while !eof()
      aadd( aMunicipio, { MUNICIPI->CODIGO, MUNICIPI->DESCRIPCIO } )
      SKIP
    end do
    if Len( aMunicipio ) == 0
       aadd( aMunicipio, { "", "" } )
    end if
  end if

  SELECT (nSelect)

return( aMunicipio )

//---------------------------------------------------------------------------//

function LeeTblCalles( Read )
static aCalles := {}

  local nSelect := Select()

  if PCount() == 1
     aCalles := {}
  end if

  SELECT CALLES
  GO TOP

  if Len( aCalles ) == 0
    while !eof()
      aadd( aCalles, { CALLES->CODIGO, CALLES->DESCRIPCIO } )
      SKIP
    end do
    if Len( aCalles ) == 0
       aadd( aCalles, { "", "" } )
    end if
  end if

  SELECT (nSelect)

return( aCalles )

//---------------------------------------------------------------------------//

function LeeTblInstalad( Read )
static aInstalad := {}

  local nSelect := Select()

  if PCount() == 1
     aInstalad := {}
  end if

  SELECT INSTALAD
  GO TOP

  if Len( aInstalad ) == 0
    while !eof()
      aadd( aInstalad, { INSTALAD->CODIGO, INSTALAD->DESCRIPCIO } )
      SKIP
    end do
    if Len( aInstalad ) == 0
       aadd( aInstalad, { "", "" } )
    end if
  end if

  SELECT (nSelect)

return( aInstalad )

//---------------------------------------------------------------------------//

function ImpMasCli( cMascara, cLogic )
   LOCAL nSelect := Select()

   SELECT CLIENTES
   SET ORDER TO 2
   Mascaras( cMascara, cLogic )
   SET ORDER TO 1
   Select( nSelect )

return NIL

//---------------------------------------------------------------------------//

function LeeTblNomencla( Read )
static aNomenclator := {}

  local nSelect := Select()

  if PCount() == 1
     aNomenclator := {}
  end if

  SELECT NOMENCLA
  GO TOP

  if Len( aNomenclator ) == 0
    while !eof()
      aadd( aNomenclator, { NOMENCLA->CODIGO, NOMENCLA->DESCRIPCIO } )
      SKIP
    end do
    if Len( aNomenclator ) == 0
       aadd( aNomenclator, { "", "" } )
    end if
  end if

  SELECT (nSelect)

return( aNomenclator )

//---------------------------------------------------------------------------//

function Zero( xVar, nLen )

   local cRet

   if ValType( xVar ) == 'C'
      nLen := Len( xVar )
      cRet := PadL( AllTrim( xVar ), nLen, "0" )
   elseif ValType( xVar ) == 'N'
      nLen := Len( AllTrim( Str( xVar ) ) )
      cRet := StrZero( xVar, nLen )
   else
      cRet := "<<ERROR IN Zero()>>"
   endif

return cRet
