/*------------------------------------------------------------------------------
     COLORES: ESTABLECE EL SET CARCATERES PARA TRABAJAR EN MODO COLOR O B&W

  (c) Francisco Morero Peyrona - 1993
      Alfonso Fraguas Bravo    - 1993

------------------------------------------------------------------------------*/

#include "TDCO.ch"


function Colores()

   do case
      case aCfg[ CFG_MONITOR ] == TV_MONO
           aClr[ CLR_SAY    ] = "W+/W, W+/W"
           aClr[ CLR_GET    ] = "W/N, W+/N,, N/W, W+/W"
           aClr[ CLR_LIST   ] = "N/W*, W+/N,, N/W*, N/W*"
           aClr[ CLR_CHECK  ] = "N/W, W+/W,, N/W,W+/W"
           aClr[ CLR_RADIO  ] = "N/W, W+/W, W, N/W,W+/W"
           aClr[ CLR_COMBO  ] = "N/W, N/W*,, W+/N"
           aClr[ CLR_BUTTON ] = "W+/N, B+/N,,, W/N"
           aClr[ CLR_BOX    ] = { "N/W", "N/W*", "N/W", "N/W","N/W" }
           aClr[ CLR_DLGBOX ] = { "N/W", "N/W*", "N/W", "N/W","N/W" }
           aClr[ CLR_BROWSE ] = { {"N/W", "N/W*", "W+/W", "N/W"}, "N/W,N/W*" }
           aClr[ CLR_NORMAL ] = "N/W,W/N,N,N,W+/N"
           aClr[ CLR_AVISO  ] = { "N+/W*", "N/W*","N/W","W+/N","N/W" }
           aClr[ CLR_ERROR  ] = "N/W,W/N"
           aClr[ CLR_H_MENU ] = {"W+/N","N/W*","B+/N","B+/N","W/N","N/W"}
           aClr[ CLR_V_MENU ] = {"W+/N","N/W*","B+/N","B+/N","W/N","N/W","W/N"}

      case aCfg[ CFG_MONITOR ] == TV_COLOR
           aClr[ CLR_SAY    ] = "W+/B, W+/B"                                                  
           aClr[ CLR_GET    ] = "N/BG, W+/BG,, N/W, R/W"
           aClr[ CLR_LIST   ] = "BG+/B, W+/BG,, GR+/B, W+/B, GR+/B"
           aClr[ CLR_CHECK  ] = "N/W, W+/W,, N/BG, W+/BG, R/W"
           aClr[ CLR_RADIO  ] = "N/W, W+/W, BG, N/BG, W+/BG, R/W"
           aClr[ CLR_COMBO  ] = "N/W, W+/BG,, GR+/B, BG+/B, R/W"
           aClr[ CLR_BUTTON ] = "N/G, W+/G, , , W/N*, GR+/G"
                                                       //LOW   y  HIGH para SAY en la caja
           aClr[ CLR_BOX    ] = { "W+/B", "N/W*", "N/W*", "BG+/B", "W+/B" }
           aClr[ CLR_DLGBOX ] = { "W+/W","N/W*", "N/W*", "N/W",   "RB/W" }
                                  // Caja browse-----------------   Browse------
           aClr[ CLR_BROWSE ] = { {"B/BG","W+/B*","GR+/BG","RB/W"}, "N/BG,BG+/B" }

           aClr[ CLR_NORMAL ] = "BG+/B, N/BG, B,N, N+/BG"
                                  // Caja------------------------      Say---
           aClr[ CLR_AVISO  ] = { "GR+/BG*", "N/GR*", "N/W*", "N+/BG*", "B/BG*" }
           aClr[ CLR_ERROR  ] = "W+/R, GR+/B"
           aClr[ CLR_H_MENU ] = {"N/BG", "W+/N", "GR+/BG", "GR+/N", "N+/BG", "N+/N"}
           aClr[ CLR_V_MENU ] = {"W+/BG", "W+/N", "GR+/BG", "GR+/N", "N+/BG", "N+/N", "N/BG"}

      case aCfg[ CFG_MONITOR ] == TV_LAPTOP
           aClr[ CLR_SAY    ] = "W+/W,W+/W"
           aClr[ CLR_GET    ] = "W/N,W+/N"
           aClr[ CLR_LIST   ] = "N/W*,W+/N,,N/W*,N/W*"
           aClr[ CLR_CHECK  ] = "N/W,W+/W,, N/W,W+/W"
           aClr[ CLR_RADIO  ] = "N/W,W+/W, W, N/W,W+/W"
           aClr[ CLR_COMBO  ] = "N/W, N/W*,, W+/N"
           aClr[ CLR_BUTTON ] = "W/N,W+/N"                 // SAY en la caja
           aClr[ CLR_BOX    ] = { "N/W","N/W*","N/W","N/W","N/W" }
           aClr[ CLR_DLGBOX ] = { "N/W","N/W*",,, "N/W" }
           aClr[ CLR_BROWSE ] = { {"N/W","N/W*","W+/W","N/W"}, "N/W,N/W*" }
           aClr[ CLR_NORMAL ] = "N/W,W/N,N,N,W+/N"
           aClr[ CLR_AVISO  ] = { "N+/W", "N/W*","N/W","W+/N","N/W" }
           aClr[ CLR_ERROR  ] = "N/W,W/N"
           aClr[ CLR_H_MENU ] = {"W+/N","N/W*","B+/N","B+/N","W/N","N/W"}
           aClr[ CLR_V_MENU ] = {"W+/N","N/W*","B+/N","B+/N","W/N","N/W","W/N"}
   endcase

return NIL
