/*------------------------------------------------------------------------------
                    MENUS AL ESTILO DE VISUAL CLIPPER

------------------------------------------------------------------------------*/

#ifndef _VC_MENU

   #define _VC_MENU

 //----------- Tareas -------------

   #define nOPEN_MENU     1
   #define nCLOSE_MENU    2
   #define nADD_ITEM      3
   #define nCREATE_MENU   4
   #define nMENU_H_COLOR  5
   #define nMENU_V_COLOR  6


 //---------- Comandos ------------

   #command DEFINE MENU => MenuTask( nOPEN_MENU )

   #command @ <nRow>, <nCol> ADD ITEM <cLbl>        ;
                             [<lAct: ACTIVE>]       ;
                             [<lChe: CHECKED>]      ;
                             [MESSAGE <cMsg>]       ;
                             [EXECUTE <cExec>]      ;
                                                 => ;
            MenuTask( nADD_ITEM,                    ;
            { <nRow>, <nCol>, <cLbl>, <.lAct.>, <.lChe.>, <cMsg>, <cExec> } )

   #command @ <nRow>, <nCol> SEPARATOR => @ <nRow>, <nCol> ADD ITEM ""

   #command END MENU => MenuTask( nCLOSE_MENU )

   #command MENU <oMenu> IS HORIZONTAL               => ;
            <oMenu> := MenuTask( nCREATE_MENU, .T. )

   #command MENU <oMenu> IS VERTICAL                 => ;
            <oMenu> := MenuTask( nCREATE_MENU, .F. )

   #command MENU HORIZONTAL COLOR IS <aColor>        => ;
            MenuTask( nMENU_H_COLOR, <aColor> )

   #command MENU VERTICAL   COLOR IS <aColor>        => ;
            MenuTask( nMENU_V_COLOR, <aColor> )

   #command ACTIVATE MENU <oMenu> TO <cVar>          => ;
            <cVar> := ExecMenu( <oMenu> )
#endif

//----------------------------------------------------------------------------//
