/*------------------------------------------------------------------------------
               FICHERO DE CABECERA PARA LA GESTION DE
                    MENUS TRADICIONALES DE TDCO++

------------------------------------------------------------------------------*/

#ifndef _MENU

   #define _MENU

   #define lACTIVE   .T.        // para cambiar el estado de un item
   #define lCHECKED  .T.        // durante el transcurso del programa

 //---------- Array MenuNew
   #define M_FOCUS    1
   #define M_OPS      2
   #define M_CLRS     3
   #define M_ANCHO    4

 //----------- Men Item
   #define M_Y         1
   #define M_X         2
   #define M_LABEL     3
   #define M_HOTKEY    4
   #define M_HOTPOS    5
   #define M_ACTIVO    6
   #define M_CHECKED   7
   #define M_nMSG      8         // La fila donde se muestra el msg
   #define M_cMSG      9         // El msg
   #define M_EXEC     10
   #define M_ITEM_LEN 10

 //----------- Status Item
   #define M_ST_SAY   1
   #define M_ST_GET   2
   #define M_ST_CHECK 3

 //---------- Colores
   #define M_SAY      1
   #define M_GET      2
   #define M_HOTSAY   3
   #define M_HOTGET   4
   #define M_INAC_SAY 5
   #define M_INAC_GET 6
   #define M_CLRCAJA  7


 /*---------------------------------------------------------------------
            DEFINICIONES DE COMANDOS PARA CREACION DE MENUS
 ----------------------------------------------------------------------*/
 //------------------  MENU HORIZONTAL  -----------------------

   #command CREATE <cNomVar> HOR_MENU  =>  <cNomVar> := {}



   #command @ <nRow>, <nCol> HOR_ITEM <cNomVar> LABEL <cLabel>             ;
                            [<act: ACTIVE>  ]                              ;
                            [<che: CHECKED> ]                              ;
                            [MESSAGE <cMsg> ]                              ;
                            [EXECUTE <xExec> [<menu: SUBMENU>]]            ;
                                                                           ;
     => AAdd( <cNomVar>, { <nRow>, <nCol>, <cLabel>,                       ;
                           <.act.>, <.che.>, [<cMsg>],                     ;
                           If( <.menu.>, <xExec>, <{xExec}> ) } )



   #command END <cNomVar> HOR_MENU [COLOR <aClr>];
     => <cNomVar> := MenuHNew( <cNomVar>, [<aClr>] )



 //------------------  MENU VERTICAL  -----------------------

   #command CREATE <cNomVar> VER_MENU  =>  <cNomVar> := {}



   #command @ <nRow>, <nCol> VER_ITEM <cNomVar> LABEL <cLabel>             ;
                            [<act: ACTIVE>  ]                              ;
                            [<che: CHECKED> ]                              ;
                            [MESSAGE <cMsg> ]                              ;
                            [EXECUTE <xExec> [<menu: SUBMENU>]]            ;
                                                                           ;
     => AAdd( <cNomVar>, { <nRow>, <nCol>, <cLabel>,                       ;
                           <.act.>, <.che.>, [<cMsg>],                     ;
                           If( <.menu.>, <xExec>, <{xExec}> ) } )

   #command END <cNomVar> VER_MENU [COLOR <aClr>];
     => <cNomVar> := MenuVNew( <cNomVar>, [<aClr>] )

#endif

//----------------------------------------------------------------------------//
